/* $Id: wmh_int.h,v 1.3 1999/06/08 00:38:20 marcus Exp $
******************************************************************************

   LibGGI BSE extension internals

   Copyright (C) 1999 Andreas Beck	[becka@ggi-project.org]
  
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _GGI_BSE_INT_H
#define _GGI_BSE_INT_H

#include <ggi/internal/internal.h>

#define HAVE_STRUCT_GGIBSE

#include "bse.h"

typedef int (ggibsefunc_alloc)(ggibse_t bob);

typedef int (ggibsefunc_move)    (ggibse_t bob, int x, int y);
typedef int (ggibsefunc_setimage)(ggibse_t bob, ggi_visual_t vis, int x, int y,
				unsigned char *alpha);
typedef int (ggibsefunc_show)    (ggibse_t bob, int show);

struct ggibse {
	struct ggibse *prev,*next;
	ggi_visual_t	vis;
	ggibsefunc_move	*move;
	ggibsefunc_show	*show;
	ggibsefunc_setimage	*setimage;
	int x,y,w,h;
	enum bsetype type;
	int hidecount;
	void *image;
	void *alpha;
	void *backgr;
};

__BEGIN_DECLS

/* Exported variables */
#ifdef BUILDING_LIBGGIBSE
extern ggi_extid    ggiBseID;
#else
IMPORTVAR ggi_extid ggiBseID;
#endif

__END_DECLS

typedef struct bse_ext {
	ggibsefunc_alloc	*alloc;
	struct ggibse *first;
} ggibseext;

#define LIBGGI_BSEEXT(vis) ((ggibseext *)LIBGGI_EXT(vis,ggiBseID))

#endif /* _GGI_BSE_INT_H */
